{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE TemplateHaskell #-}
{-# LANGUAGE QuasiQuotes     #-}

-- |
-- Module:      Database.Ocilib.Oci
-- Copyright:   (c) 2016 Thierry Bourrillon
--              (c) 2016 FPInsight, Eurl.
-- License:     BSD3
-- Maintainer:  Thierry Bourrillon <thierry.bourrillon@fpinsight.com>
-- Stability:   experimental
-- Portability: portable
--
--

module Database.Ocilib.Oci
    ( ociCtx
    , OCI_Pool
    , OCI_Connection
    , OCI_Statement
    , OCI_Bind
    , OCI_Resultset
    , OCI_Column
    , OCI_Lob
    , OCI_File
    , OCI_Transaction
    , OCI_Long
    , OCI_Date
    , OCI_Timestamp
    , OCI_Interval
    , OCI_Object
    , OCI_Coll
    , OCI_Elem
    , OCI_Iter
    , OCI_Ref
    , OCI_TypeInfo
    , OCI_HashTable
    , OCI_Error
    , OCI_Mutex
    , OCI_Thread
    , OCI_DirPath
    , OCI_Subscription
    , OCI_Event
    , OCI_Msg
    , OCI_Agent
    , OCI_Dequeue
    , OCI_Enqueue
    ) where

import qualified Data.Map as Map
import qualified Language.C.Inline as C
import           Language.C.Inline.Context
import qualified Language.C.Types as C
import qualified Language.Haskell.TH as TH

ociCtx :: C.Context
ociCtx = mempty { ctxTypesTable = ociTypesTable }

data OCI_Pool
data OCI_Connection
data OCI_Statement
data OCI_Bind
data OCI_Resultset
data OCI_Column
data OCI_Lob
data OCI_File
data OCI_Transaction
data OCI_Long
data OCI_Date
data OCI_Timestamp
data OCI_Interval
data OCI_Object
data OCI_Coll
data OCI_Elem
data OCI_Iter
data OCI_Ref
data OCI_TypeInfo
data OCI_HashTable
data OCI_Error
data OCI_Mutex
data OCI_Thread
data OCI_DirPath
data OCI_Subscription
data OCI_Event
data OCI_Msg
data OCI_Agent
data OCI_Dequeue
data OCI_Enqueue

ociTypesTable :: Map.Map C.TypeSpecifier TH.TypeQ
ociTypesTable = Map.fromList
    [ (C.TypeName "OCI_Pool"        , [t| OCI_Pool         |])
    , (C.TypeName "OCI_Connection"  , [t| OCI_Connection   |])
    , (C.TypeName "OCI_Statement"   , [t| OCI_Statement    |])
    , (C.TypeName "OCI_Bind"        , [t| OCI_Bind         |])
    , (C.TypeName "OCI_Resultset"   , [t| OCI_Resultset    |])
    , (C.TypeName "OCI_Column"      , [t| OCI_Column       |])
    , (C.TypeName "OCI_Lob"         , [t| OCI_Lob          |])
    , (C.TypeName "OCI_File"        , [t| OCI_File         |])
    , (C.TypeName "OCI_Transaction" , [t| OCI_Transaction  |])
    , (C.TypeName "OCI_Long"        , [t| OCI_Long         |])
    , (C.TypeName "OCI_Date"        , [t| OCI_Date         |])
    , (C.TypeName "OCI_Timestamp"   , [t| OCI_Timestamp    |])
    , (C.TypeName "OCI_Interval"    , [t| OCI_Interval     |])
    , (C.TypeName "OCI_Object"      , [t| OCI_Object       |])
    , (C.TypeName "OCI_Coll"        , [t| OCI_Coll         |])
    , (C.TypeName "OCI_Elem"        , [t| OCI_Elem         |])
    , (C.TypeName "OCI_Iter"        , [t| OCI_Iter         |])
    , (C.TypeName "OCI_Ref"         , [t| OCI_Ref          |])
    , (C.TypeName "OCI_TypeInfo"    , [t| OCI_TypeInfo     |])
    , (C.TypeName "OCI_HashTable"   , [t| OCI_HashTable    |])
    , (C.TypeName "OCI_Error"       , [t| OCI_Error        |])
    , (C.TypeName "OCI_Mutex"       , [t| OCI_Mutex        |])
    , (C.TypeName "OCI_Thread"      , [t| OCI_Thread       |])
    , (C.TypeName "OCI_DirPath"     , [t| OCI_DirPath      |])
    , (C.TypeName "OCI_Subscription", [t| OCI_Subscription |])
    , (C.TypeName "OCI_Event"       , [t| OCI_Event        |])
    , (C.TypeName "OCI_Msg"         , [t| OCI_Msg          |])
    , (C.TypeName "OCI_Agent"       , [t| OCI_Agent        |])
    , (C.TypeName "OCI_Dequeue"     , [t| OCI_Dequeue      |])
    , (C.TypeName "OCI_Enqueue"     , [t| OCI_Enqueue      |])
    ]
